import {
  Loader, Http, Metadata, IDictionary, IEventParam,
} from '@zeedhi/core';

import {
  Form, LoadingService, List, Select, Tabs,
} from '@zeedhi/common';
  
export class Pla01900ParametrosPlanejamentoController {
  // Utils
  
  private utilities = Loader.getInstance('Utilities');
  
  public appController = Loader.getInstance('AppController');
  
  // Flags
  
  public disabledButtonsGeral = true;
  
  public disabledButtonsPlaneja = true;
  
  // Parâmetros da paramgeral
  
  private qtDiaBloqCar = '';
  
  private cdcabohidra = '';
  
  private cdproteina = '';
  
  private cdalcool = '';
  
  private cdlipidios = '';
  
  private cdcalorias = '';
  
  private cdacidgraxos = '';
  
  private cdacucares = '';
  
  private idutrpadca = false;
  
  private paramGeralDict = {};
  
  // Parâmetros da paramplaneja e filial
  
  private filialFilterValue = '';
  
  private idcardiautil = '';
  
  private idconsgrprat = '';
  
  private idservincfilagr = '';
  
  private idcuspadcar = '';
  
  private cdservretpme = '';
  
  private cdnutrrelat1 = '';
  
  private cdnutrrelat2 = '';
  
  private cdnutrrelat3 = '';
  
  private cdnutrrelat4 = '';
  
  private idprinvenreti = '';
  
  private cdtpretipadr = '';
  
  private cdtipocustorea = '';
  
  private cdtipocustopla = '';
  
  private idexibecusto = '';
  
  private idperccome = '';
  
  private txmenscardia = '';
  
  private txmenscarsem = '';
  
  private cdtcaconsper = '';
  
  private cdtcaconsfix = '';
  
  private nrcorcardesp: any = '';
  
  private nrcornutil: any = '';
  
  private nrcornalte: any = '';
  
  private nrcorsafra: any = '';
  
  private nrcorinicsaf: any = '';
  
  private nrcorentrsaf: any = '';
  
  private idcomcusperc = '';
  
  private paramPlanejaDict = {};
  
  // Form
  
  public submitFunc() {
    const tabPrincipal: Tabs = Metadata.getInstance('principalTabParametros');
    const activeTab = tabPrincipal.activeTab;
    
    if (activeTab === 0) this.submitParametrosPlanGeralCard();
    else this.submitParametrosPlaneja();
  }
  
  public returnActiveTab() {
    const subTabPlaneja: Tabs = Metadata.getInstance('subTabParametros');
    const activeSubTab = subTabPlaneja.activeTab;
    const arrayHelper = ['Planejamento', 'Elaboracao', 'MensCard', 'ReqRetirada', 'SafraCard'];
    const nameActive = arrayHelper[activeSubTab];
    
    return nameActive;
  }
  
  public cancelFunc() {
    const tabPrincipal: Tabs = Metadata.getInstance('principalTabParametros');
    const activeTab = tabPrincipal.activeTab;
    
    if (activeTab === 0) this.cancelFormGeral();
    else this.cancelFormPlaneja();
  }
  
  public reloadParamGeral() {
    this.getParamGeral();
  }
  
  public reloadParamPlaneja() {
    this.getParamPlanejaEFilial();
  }
  
  public cancelForm() {
    this.disabledButtonsGeral = true;
    this.disabledButtonsPlaneja = true;
  }
  
  public cancelFormGeral() {
    this.disabledButtonsGeral = true;
    this.reloadParamGeral();
    this.closeListGroup('groupListCardapio');
    this.openListGroup('groupListCardapio');
  }
  
  public cancelFormPlaneja({ component }: IDictionary = []) {
    const tabName = component ? component.name.substr(12) : this.returnActiveTab();
    
    this.disabledButtonsPlaneja = true;
    this.closeListGroup(`groupList${tabName}`);
    this.openListGroup(`groupList${tabName}`);
    this.reloadParamPlaneja();
  }
  
  public changeFieldGeral() {
    this.disabledButtonsGeral = false;
  }
  
  public changeFieldPlaneja() {
    if (this.filialFilterValue) this.disabledButtonsPlaneja = false;
    else Metadata.getInstance<Form>('formUnidade').validate();
  }
  
  private callLoading() {
    LoadingService.show(' ');
    window.setTimeout(() => LoadingService.hide(), 1000);
    window.setTimeout(() => this.utilities.showAlert('alert', 'pme::salvoComSucesso', 'success'), 1100);
  }
  
  private closeListGroup(nameComponent: string) {
    const listElement: List = Metadata?.getInstance(nameComponent);
    
    if (listElement) listElement.childrenInstances.forEach((ele) => { ele.opened = false; });
  }
  
  private openListGroup(nameComponent: string) {
    const listElement: List = Metadata?.getInstance(nameComponent);
    
    if (listElement) listElement.childrenInstances.forEach((ele) => { ele.opened = true; });
  }
  
  // Filters
  
  public setFilterFilial({ component }: IEventParam<Select>) {
    const filter = [
      {
        name: 'CDFILCENTPME',
        operator: '=',
        value: this.filialFilterValue,
      },
    ];
    
    component.datasource.filter = filter;
    component.datasource.get();
  }
  
  public setFilterServicoRet({ component }: IEventParam<Select>) {
    const filter = [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: this.filialFilterValue,
      },
    ];
    
    component.datasource.filter = filter;
    component.datasource.get();
  }
  
  public setFilialLogada({ component }: IDictionary) {
    component.value = localStorage.getItem('CDFILIALLOGADA');
  }
  
  // Getters
  
  public getParamGeral() {
    Http.get('/paramgeral').then((paramgeral) => {
      this.qtDiaBloqCar = paramgeral.data.data[0]?.QTDIABLOQCAR;
      this.cdcabohidra = paramgeral.data.data[0]?.CDCARBOHIDRA;
      this.cdproteina = paramgeral.data.data[0]?.CDPROTEINA;
      this.cdalcool = paramgeral.data.data[0]?.CDALCOOL;
      this.cdlipidios = paramgeral.data.data[0]?.CDLIPIDIOS;
      this.cdcalorias = paramgeral.data.data[0]?.CDCALORIAS;
      this.cdacidgraxos = paramgeral.data.data[0]?.CDACIDGRAXOS;
      this.cdacucares = paramgeral.data.data[0]?.CDACUCARES;
      this.idutrpadca = paramgeral.data.data[0]?.IDUTRPADCA;
    });
  }
  
  public getParamPlanejaEFilial() {
    this.utilities.getParamPlaneja(this.filialFilterValue).then((paramplaneja: IDictionary) => {
      this.idcardiautil = paramplaneja?.IDCARDIAUTIL;
      this.idconsgrprat = paramplaneja?.IDCONSGRPRAT;
      this.idservincfilagr = paramplaneja?.IDSERVINCFILAGR;
      this.idcuspadcar = paramplaneja?.IDCUSPADCAR;
      this.cdservretpme = paramplaneja?.CDSERVRETPME;
      this.cdnutrrelat1 = paramplaneja?.CDNUTRRELAT1;
      this.cdnutrrelat2 = paramplaneja?.CDNUTRRELAT2;
      this.cdnutrrelat3 = paramplaneja?.CDNUTRRELAT3;
      this.cdnutrrelat4 = paramplaneja?.CDNUTRRELAT4;
      this.idprinvenreti = paramplaneja?.IDPRINVENRETI;
      this.cdtpretipadr = paramplaneja?.CDTPRETIPADR;
      this.cdtipocustopla = paramplaneja?.CDTIPOCUSTOPLA;
      this.cdtipocustorea = paramplaneja?.CDTIPOCUSTOREA;
      this.idexibecusto = paramplaneja?.IDEXIBECUSTO;
      this.idperccome = paramplaneja?.IDPERCCOME;
      this.txmenscardia = paramplaneja?.TXMENSCARDIA;
      this.txmenscarsem = paramplaneja?.TXMENSCARSEM;
      this.cdtcaconsper = paramplaneja?.CDTCACONSPER;
      this.cdtcaconsfix = paramplaneja?.CDTCACONSFIX;
      this.nrcorcardesp = this.utilities.TColorToHex(paramplaneja?.NRCORCARDESP);
      this.nrcornutil = this.utilities.TColorToHex(paramplaneja?.NRCORNUTIL);
      this.nrcornalte = this.utilities.TColorToHex(paramplaneja?.NRCORNALTE);
      this.nrcorsafra = this.utilities.TColorToHex(paramplaneja?.NRCORSAFRA);
      this.nrcorinicsaf = this.utilities.TColorToHex(paramplaneja?.NRCORINICSAF);
      this.nrcorentrsaf = this.utilities.TColorToHex(paramplaneja?.NRCORENTRSAF);
    });
    
    this.utilities.getParamFilial(this.filialFilterValue).then((paramfilial: IDictionary) => {
      this.idcomcusperc = paramfilial?.IDCOMCUSPERC;
    });
    
    this.openListGroup(`groupList${this.returnActiveTab()}`);
  }
  
  // Submits
  
  public submitParametrosPlanGeralCard() {
    const formGeralCard = Metadata.getInstance<Form>('formTabCardapio');
    
    if (formGeralCard.validate()) {
      this.paramGeralDict = {
        QTDIABLOQCAR: this.qtDiaBloqCar,
        CDCARBOHIDRA: this.cdcabohidra,
        CDPROTEINA: this.cdproteina,
        CDALCOOL: this.cdalcool,
        CDLIPIDIOS: this.cdlipidios,
        CDCALORIAS: this.cdcalorias,
        CDACIDGRAXOS: this.cdacidgraxos,
        CDACUCARES: this.cdacucares,
        IDUTRPADCA: this.idutrpadca,
      };
      
      this.callPlanGeralSave(this.paramGeralDict);
    }
  }
  
  public submitParametrosPlaneja({ component }: IDictionary = []) {
    const formFilterUnidade = Metadata.getInstance<Form>('formUnidade');
    const tabName = component ? component.name : this.returnActiveTab();
    
    if (formFilterUnidade.validate()) {
      this.fillParamPlanejaDict(tabName);
      this.callPlanejaSave(this.paramPlanejaDict);
    }
  }
  
  // Call save
  
  private callPlanGeralSave(row: IDictionary) {
    Http.post('/updateParamGeral', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.cancelFormGeral();
      this.cancelForm();
      this.openListGroup('groupListCardapio');
    });
  }
  
  private callPlanejaSave(row: IDictionary) {
    Http.post('/updateParamPlaneja', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.closeListGroup(`groupList${row.tab}`);
      this.disabledButtonsPlaneja = true;
      this.openListGroup(`groupList${row.tab}`);
    });
  }

  // Helpers
  
  private fillParamPlanejaDict(tabName: string) {
    if (tabName.includes('MensCard')) {
      this.paramPlanejaDict = {
        TXMENSCARSEM: this.txmenscarsem,
        TXMENSCARDIA: this.txmenscardia,
        CDFILIAL: this.filialFilterValue,
        tab: 'MensCard',
      };
    } else if (tabName.includes('ReqRetirada')) {
      this.paramPlanejaDict = {
        CDTCACONSPER: this.cdtcaconsper,
        CDTCACONSFIX: this.cdtcaconsfix,
        CDFILIAL: this.filialFilterValue,
        tab: 'ReqRetirada',
      };
    } else if (tabName.includes('Elaboracao')) {
      this.paramPlanejaDict = {
        CDTIPOCUSTOPLA: this.cdtipocustopla,
        CDTIPOCUSTOREA: this.cdtipocustorea,
        IDEXIBECUSTO: this.idexibecusto,
        IDPERCCOME: this.idperccome,
        CDFILIAL: this.filialFilterValue,
        tab: 'Elaboracao',
      };
    } else if (tabName.includes('Planejamento')) {
      this.paramPlanejaDict = {
        IDCARDIAUTIL: this.idcardiautil,
        IDCONSGRPRAT: this.idconsgrprat,
        IDSERVINCFILAGR: this.idservincfilagr,
        IDCUSPADCAR: this.idcuspadcar,
        IDCOMCUSPERC: this.idcomcusperc,
        CDSERVRETPME: this.cdservretpme,
        CDNUTRRELAT1: this.cdnutrrelat1,
        CDNUTRRELAT2: this.cdnutrrelat2,
        CDNUTRRELAT3: this.cdnutrrelat3,
        CDNUTRRELAT4: this.cdnutrrelat4,
        IDPRINVENRETI: this.idprinvenreti,
        CDTPRETIPADR: this.cdtpretipadr,
        CDFILIAL: this.filialFilterValue,
        tab: 'Planejamento',
      };
    } else if (tabName.includes('SafraCard')) {
      const nrcorcardesp = this.utilities.hexToRgbInline(this.nrcorcardesp).split('.', 3);
      const nrcornutil = this.utilities.hexToRgbInline(this.nrcornutil).split('.', 3);
      const nrcornalte = this.utilities.hexToRgbInline(this.nrcornalte).split('.', 3);
      const nrcorsafra = this.utilities.hexToRgbInline(this.nrcorsafra).split('.', 3);
      const nrcorinicsaf = this.utilities.hexToRgbInline(this.nrcorinicsaf).split('.', 3);
      const nrcorentrsaf = this.utilities.hexToRgbInline(this.nrcorentrsaf).split('.', 3);
      this.paramPlanejaDict = {
        NRCORCARDESP: this.utilities.RGBToTColor(nrcorcardesp[0], nrcorcardesp[1], nrcorcardesp[2]),
        NRCORNUTIL: this.utilities.RGBToTColor(nrcornutil[0], nrcornutil[1], nrcornutil[2]),
        NRCORNALTE: this.utilities.RGBToTColor(nrcornalte[0], nrcornalte[1], nrcornalte[2]),
        NRCORSAFRA: this.utilities.RGBToTColor(nrcorsafra[0], nrcorsafra[1], nrcorsafra[2]),
        NRCORINICSAF: this.utilities.RGBToTColor(nrcorinicsaf[0], nrcorinicsaf[1], nrcorinicsaf[2]),
        NRCORENTRSAF: this.utilities.RGBToTColor(nrcorentrsaf[0], nrcorentrsaf[1], nrcorentrsaf[2]),
        CDFILIAL: this.filialFilterValue,
        tab: 'SafraCard',
      };
    }
  }
}
